#include <stdio.h>
#include <fcntl.h>		/* ATM */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/resource.h>

/*#define PROG 		"/usr/games/sxtrek"*/
/*#define LOGFILE		"/usr/games/lib/xtrekII/xtreklog"*/
#define PROG		"/usr/local/games/ntserv"	/* ATM */
#define LOGFILE		"/usr/local/games/lib/netrek/xtsocklog"	/* ATM */

#define SP_BADVERSION 21
struct badversion_spacket {
    char type;
    char why;
    char pad2;
    char pad3;
};

extern char peerhostname[];	/* Defined in access.c */

main(argc, argv)
int argc;
char **argv;
{
	FILE    *fp;
	int	fd;
	long	curtime;
	char	logname[BUFSIZ];
	struct	rlimit	rl;
	struct  badversion_spacket packet;
	int	game;
	char  	version[81];

	(void) chdir("/usr/tmp");

/*
	getrlimit(RLIMIT_CPU, &rl);
	rl.rlim_cur = 60;
	setrlimit(RLIMIT_CPU, &rl);
*/	/* ATM */

	fd = open(LOGFILE, O_CREAT | O_WRONLY | O_APPEND, 0600);
top:
	if (host_access(NULL) == 0) {
		packet.type=SP_BADVERSION;
		packet.why=1;
		write(0, (char *) &packet, sizeof(packet));
		time(&curtime);
		strcpy(logname, "Denied ");
		strcat(logname, peerhostname);
		strcat(logname, "\t");
		strcat(logname, ctime(&curtime));
		if (fd!=-1) write(fd, logname, strlen(logname));

		exit(0);
	}

	time(&curtime);
	strcpy(logname, peerhostname);
	strcat(logname, "\t");
	strcat(logname, ctime(&curtime));
	if (fd!=-1) write(fd, logname, strlen(logname));
	if (fd!=-1) close(fd);

	setuid(2);
	setgid(2);

	rl.rlim_cur = rl.rlim_max;
/*	setrlimit(RLIMIT_CPU, &rl);*/	/* ATM */

	execl(PROG, PROG, peerhostname, 0);

	/* NOT REACHED (if PROG exists!) */
	/* don't exit to inetd with an error */
	exit(0);
}
